package jp.gr.java_conf.skrb.game.trivia.client;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Properties;
import javax.swing.JFrame;
import javax.swing.JLabel;

import jp.gr.java_conf.skrb.game.trivia.util.Counter;
import jp.gr.java_conf.skrb.game.trivia.util.CounterEvent;
import jp.gr.java_conf.skrb.game.trivia.util.CounterListener;
import jp.gr.java_conf.skrb.game.trivia.util.CounterPanel;

public class DefaultClientView implements ClientView {
    private TriviaClient parent;
    private ClientPanel panel;

    private JFrame frame;

    public DefaultClientView(TriviaClient parent, 
                             String name, 
                             Counter counter, 
                             Properties properties) {
        this.parent = parent;
        
        setup(name, counter, properties);
    }

    private void setup(String name, Counter counter, Properties properties) {
        frame = new JFrame("Trivia Client");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setLocationByPlatform(true);

        JLabel nameLabel = new JLabel(name, JLabel.CENTER);
        Font currentFont = nameLabel.getFont();
        nameLabel.setFont(new Font(currentFont.getName(), 
                                   currentFont.getStyle(),
                                   currentFont.getSize() + 16));
        frame.getContentPane().add(nameLabel, BorderLayout.NORTH);

        panel = new ClientPanel(counter, properties);
        panel.addCounterListener(new CounterListener() {
            public void counterIncremented(CounterEvent event) {
                parent.counterIncremented(event.getCount());
            }
        });

        panel.setEnabled(false);

        frame.getContentPane().add(panel, BorderLayout.CENTER);
        frame.pack();
        frame.setVisible(true);
    }

    public void updateView() {
        panel.repaint();
    }

    public void setEnabled(boolean flag) {
        panel.setEnabled(flag);
    }
}
