package jp.gr.java_conf.skrb.game.trivia.util;

public class Counter {
    public static final int MAX = 20;

    protected int count;
    protected boolean valid;

    public Counter() {
        count = 0;
        valid = true;
    }

    public synchronized int getCount() {
        return count;
    }

    public synchronized void setCount(int count) {
        this.count = count;

        if (this.count > MAX) {
            this.count = MAX;
            valid = false;
        }
    }

    public synchronized void increment() {
        if (count < MAX) {
            count++;
        } else {
            valid = false;
        }
    }

    public synchronized void reset() {
        count = 0;
        valid = true;
    }

    public synchronized boolean isValid() {
        return valid;
    }
}
